Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3791)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3792)
@@ -5579,86 +3276,45 @@
 !
 !--    All PEs are top-border PEs
-       CALL pmci_interp_1sto_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,      &
-                                r2yo, r1zw, r2zw, kctw, iflo, ifuo,            &
-                                jflo, jfuo, kflw, kfuw, ijkfc_w, 'w' )
-       CALL pmci_interp_1sto_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,      &
-                                r2yo, r1zo, r2zo, kcto, iflu, ifuu,            &
-                                jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
-       CALL pmci_interp_1sto_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,      &
-                                r2yv, r1zo, r2zo, kcto, iflo, ifuo,            &
-                                jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
-
+       CALL pmci_interp_1sto_t( w, wc, kctw, iflo, ifuo, jflo, jfuo, 'w' )
+       CALL pmci_interp_1sto_t( u, uc, kcto, iflu, ifuu, jflo, jfuo, 'u' )
+       CALL pmci_interp_1sto_t( v, vc, kcto, iflo, ifuo, jflv, jfuv, 'v' )
 
        IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.         &
             (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.          &
                .NOT. constant_diffusion ) )  THEN
-!          CALL pmci_interp_1sto_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
-!                                   r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
-!                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 'e' )
+!          CALL pmci_interp_1sto_t( e, ec, kcto, iflo, ifuo, jflo, jfuo, 'e' )
 !
 !--       Interpolation of e is replaced by the Neumann condition. 
           e(nzt+1,nys:nyn,nxl:nxr) = e(nzt,nys:nyn,nxl:nxr)
-
        ENDIF
 
        IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-          CALL pmci_interp_1sto_t( diss, dissc, ico, jco, kco, r1xo, r2xo,     &
-                                   r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,   &
-                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+          CALL pmci_interp_1sto_t( diss, dissc, kcto, iflo, ifuo, jflo, jfuo, 's' )
        ENDIF
 
        IF ( .NOT. neutral )  THEN
-          CALL pmci_interp_1sto_t( pt, ptc, ico, jco, kco, r1xo, r2xo,         &
-                                   r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,   &
-                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+          CALL pmci_interp_1sto_t( pt, ptc, kcto, iflo, ifuo, jflo, jfuo, 's' )
        ENDIF
 
        IF ( humidity )  THEN
-
-          CALL pmci_interp_1sto_t( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo,    &
-                                   r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
-                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
-
+          CALL pmci_interp_1sto_t( q, q_c, kcto, iflo, ifuo, jflo, jfuo, 's' )
           IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
-
-             CALL pmci_interp_1sto_t( qc, qcc, ico, jco, kco, r1xo, r2xo, r1yo,&
-                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
-
-             CALL pmci_interp_1sto_t( nc, ncc, ico, jco, kco, r1xo, r2xo, r1yo,&
-                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
-
+             CALL pmci_interp_1sto_t( qc, qcc, kcto, iflo, ifuo, jflo, jfuo, 's' )
+             CALL pmci_interp_1sto_t( nc, ncc, kcto, iflo, ifuo, jflo, jfuo, 's' )
           ENDIF
-
           IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
-
-
-             CALL pmci_interp_1sto_t( qr, qrc, ico, jco, kco, r1xo, r2xo, r1yo,&
-                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
-
-             CALL pmci_interp_1sto_t( nr, nrc, ico, jco, kco, r1xo, r2xo, r1yo,&
-                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
-
+             CALL pmci_interp_1sto_t( qr, qrc, kcto, iflo, ifuo, jflo, jfuo, 's' )
+             CALL pmci_interp_1sto_t( nr, nrc, kcto, iflo, ifuo, jflo, jfuo, 's' )
           ENDIF
-
        ENDIF
 
        IF ( passive_scalar )  THEN
-          CALL pmci_interp_1sto_t( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,     &
-                                   r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
-                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+          CALL pmci_interp_1sto_t( s, sc, kcto, iflo, ifuo, jflo, jfuo, 's' )
        ENDIF
 
        IF ( air_chemistry  .AND.  nest_chemistry )  THEN
           DO  n = 1, nspec
-             CALL pmci_interp_1sto_t( chem_species(n)%conc,                    &
-                                      chem_spec_c(:,:,:,n),                    &
-                                      ico, jco, kco, r1xo, r2xo,               &
-                                      r1yo, r2yo, r1zo, r2zo,                  &
-                                      kcto, iflo, ifuo, jflo, jfuo,            &
-                                      kflo, kfuo, ijkfc_s, 's' )
+             CALL pmci_interp_1sto_t( chem_species(n)%conc, chem_spec_c(:,:,:,n),                   &
+                                      kcto, iflo, ifuo, jflo, jfuo, 's' )
           ENDDO
        ENDIF
@@ -5674,19 +3330,15 @@
 !--   Note that TKE is not anterpolated.
       IMPLICIT NONE
-
       INTEGER(iwp) ::  n          !< running index for number of chemical species
 
-      CALL pmci_anterp_tophat( u,  uc,  kcto, iflu, ifuu, jflo, jfuo, kflo,    &
-                               kfuo, ijkfc_u, 'u' )
-      CALL pmci_anterp_tophat( v,  vc,  kcto, iflo, ifuo, jflv, jfuv, kflo,    &
-                               kfuo, ijkfc_v, 'v' )
-      CALL pmci_anterp_tophat( w,  wc,  kctw, iflo, ifuo, jflo, jfuo, kflw,    &
-                               kfuw, ijkfc_w, 'w' )
+      
+      CALL pmci_anterp_tophat( u,  uc,  kcto, iflu, ifuu, jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
+      CALL pmci_anterp_tophat( v,  vc,  kcto, iflo, ifuo, jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
+      CALL pmci_anterp_tophat( w,  wc,  kctw, iflo, ifuo, jflo, jfuo, kflw, kfuw, ijkfc_w, 'w' )
 !
 !--   Anterpolation of TKE and dissipation rate if parent and child are in 
 !--   RANS mode.
       IF ( rans_mode_parent  .AND.  rans_mode )  THEN
-         CALL pmci_anterp_tophat( e, ec, kcto, iflo, ifuo, jflo, jfuo, kflo,   &
-                                  kfuo, ijkfc_s, 'e' )
+         CALL pmci_anterp_tophat( e, ec, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 'e' )
 !
 !--      Anterpolation of dissipation rate only if TKE-e closure is applied.
@@ -5699,19 +3351,17 @@
 
       IF ( .NOT. neutral )  THEN
-         CALL pmci_anterp_tophat( pt, ptc, kcto, iflo, ifuo, jflo, jfuo, kflo, &
-                                  kfuo, ijkfc_s, 'pt' )
+         CALL pmci_anterp_tophat( pt, ptc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 'pt' )
       ENDIF
 
       IF ( humidity )  THEN
 
-         CALL pmci_anterp_tophat( q, q_c, kcto, iflo, ifuo, jflo, jfuo, kflo,  &
-                                  kfuo, ijkfc_s, 'q' )
+         CALL pmci_anterp_tophat( q, q_c, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 'q' )
 
          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
-            CALL pmci_anterp_tophat( qc, qcc, kcto, iflo, ifuo, jflo, jfuo,    &
+            CALL pmci_anterp_tophat( qc, qcc, kcto, iflo, ifuo, jflo, jfuo,                         &
                                      kflo, kfuo, ijkfc_s, 'qc' )
-
-            CALL pmci_anterp_tophat( nc, ncc, kcto, iflo, ifuo, jflo, jfuo,    &
+            
+            CALL pmci_anterp_tophat( nc, ncc, kcto, iflo, ifuo, jflo, jfuo,                         &
                                      kflo, kfuo, ijkfc_s, 'nc' )
 
@@ -5720,8 +3370,8 @@
          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
-            CALL pmci_anterp_tophat( qr, qrc, kcto, iflo, ifuo, jflo, jfuo,    &
+            CALL pmci_anterp_tophat( qr, qrc, kcto, iflo, ifuo, jflo, jfuo,                         &
                                      kflo, kfuo, ijkfc_s, 'qr' )
 
-            CALL pmci_anterp_tophat( nr, nrc, kcto, iflo, ifuo, jflo, jfuo,    &
+            CALL pmci_anterp_tophat( nr, nrc, kcto, iflo, ifuo, jflo, jfuo,                         &
                                      kflo, kfuo, ijkfc_s, 'nr' )
 
@@ -5731,14 +3381,11 @@
 
       IF ( passive_scalar )  THEN
-         CALL pmci_anterp_tophat( s, sc, kcto, iflo, ifuo, jflo, jfuo, kflo,   &
-                                  kfuo, ijkfc_s, 's' )
+         CALL pmci_anterp_tophat( s, sc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
       ENDIF
 
       IF ( air_chemistry  .AND.  nest_chemistry )  THEN
          DO  n = 1, nspec
-            CALL pmci_anterp_tophat( chem_species(n)%conc,                     &
-                                     chem_spec_c(:,:,:,n),                     &
-                                     kcto, iflo, ifuo, jflo, jfuo, kflo,       &
-                                     kfuo, ijkfc_s, 's' )
+            CALL pmci_anterp_tophat( chem_species(n)%conc, chem_spec_c(:,:,:,n),                    &
+                                     kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
          ENDDO
       ENDIF
@@ -5748,9 +3395,5 @@
 
 
-   SUBROUTINE pmci_interp_1sto_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
-                                   r2z, logc, logc_ratio, logc_kbounds,        &
-                                   nzt_topo_nestbc,                            &
-                                   kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc,   &
-                                   edge, var )
+   SUBROUTINE pmci_interp_1sto_lr( f, fc, kct, jfl, jfu, kfl, kfu, edge, var )
 !
 !--   Interpolation of ghost-node values used as the child-domain boundary
@@ -5758,113 +3401,30 @@
       IMPLICIT NONE
 
-      INTEGER(iwp) ::  nzt_topo_nestbc   !<
-
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                                      INTENT(INOUT) ::  f       !<
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
-                                      INTENT(IN)    ::  fc      !<
-      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nys:nyn),          &
-                                      INTENT(IN)    ::  logc_ratio   !<
-!AH      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x     !<
-!AH      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x     !<
-!AH      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y     !<
-!AH      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y     !<
-      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x     !<
-      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x     !<
-      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y     !<
-      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y     !<
-
-!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z     !<
-!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z     !<
-      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z     !<
-      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z     !<
-      
-
-      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic     !<
-      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc     !<
-!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !<
-      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc     !<
-      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nys:nyn),                &
-                                          INTENT(IN)           :: logc   !<
-      INTEGER(iwp), DIMENSION(1:2,nys:nyn), INTENT(IN)         :: logc_kbounds !<
-
-      INTEGER(iwp) :: kct
-
-!AH
-!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-!AH
-
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-
-!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-
-      CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 'l', 'r', 's' or 'n' 
-      CHARACTER(LEN=1), INTENT(IN) ::  var    !< Variable symbol: 'u', 'v', 'w' or 's'
-
-      INTEGER(iwp) ::  i        !< Lower bound of the running index ia
-      INTEGER(iwp) ::  ia       !< i-index running over the parent-grid cell on the boundary 
-      INTEGER(iwp) ::  iaw      !< Reduced ia-index for workarr_lr
-      INTEGER(iwp) ::  iawbc    !< iaw-index pointing to the boundary-value nodes (either 0 or igsr-1)      
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f   !< Child-grid array
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)        ::  fc  !< Parent-grid array
+      INTEGER(iwp) :: kct                                     !< The parent-grid index in z-direction just below the boundary value node
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl  !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu  !< Indicates end index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl  !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu  !< Indicates end index of child cells belonging to certain parent cell - z direction
+      CHARACTER(LEN=1), INTENT(IN) ::  edge                   !< Edge symbol: 'l' or 'r'
+      CHARACTER(LEN=1), INTENT(IN) ::  var                    !< Variable symbol: 'u', 'v', 'w' or 's'
+!
+!--   Local variables:
       INTEGER(iwp) ::  ib       !< Fixed i-index pointing to the node just behind the boundary-value node
       INTEGER(iwp) ::  ibc      !< Fixed i-index pointing to the boundary-value nodes (either i or iend)
       INTEGER(iwp) ::  ibgp     !< Index running over the redundant boundary ghost points in i-direction
-!AH      INTEGER(iwp) ::  ibeg     !< i-index pointing to the starting point of workarr_lr in the i-direction 
-      INTEGER(iwp) ::  iend     !< Upper bound of the running index ia
       INTEGER(iwp) ::  ierr     !< MPI error code
-      INTEGER(iwp) ::  ijk      !< Running index for all child-grid cells within the anterpolation cell
-      INTEGER(iwp) ::  iw       !< i-index for wall_flags_0
       INTEGER(iwp) ::  j        !< Running index in the y-direction
-      INTEGER(iwp) ::  jco      !<
-      INTEGER(iwp) ::  jcorr    !<
-      INTEGER(iwp) ::  jinc     !<
-      INTEGER(iwp) ::  jw       !< j-index for wall_flags_0
-      INTEGER(iwp) ::  j1       !<
       INTEGER(iwp) ::  k        !< Running index in the z-direction
-      INTEGER(iwp) ::  k_wall   !< Vertical index of topography top
-      INTEGER(iwp) ::  kco      !<
-      INTEGER(iwp) ::  kcorr    !<
-      INTEGER(iwp) ::  kw       !< k-index for wall_flags_0
-      INTEGER(iwp) ::  k1       !<
-      INTEGER(iwp) ::  l        !< Parent-grid running index in the x-direction
       INTEGER(iwp) ::  lbeg     !< l-index pointing to the starting point of workarrc_lr in the l-direction 
-      INTEGER(iwp) ::  lp1      !< l+1
-      INTEGER(iwp) ::  loff     !< l-offset needed on the right boundary to correctly refer to boundary ghost points
-      INTEGER(iwp) ::  lw       !< Reduced l-index for workarrc_lr
+      INTEGER(iwp) ::  lw       !< Reduced l-index for workarrc_lr pointing to the boundary ghost node
+      INTEGER(iwp) ::  lwp      !< Reduced l-index for workarrc_lr pointing to the first prognostic node
       INTEGER(iwp) ::  m        !< Parent-grid running index in the y-direction
-      INTEGER(iwp) ::  mnorthv  !< Upshift by one for the upper bound of index m in case of var == 'v'
-      INTEGER(iwp) ::  mp1      !< m+1
       INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
-      INTEGER(iwp) ::  np1      !< n+1
-      INTEGER(iwp) ::  ntopw    !< Upshift by one for the upper bound of index n in case of var == 'w'
-      INTEGER(iwp) ::  var_flag !< Variable flag for BTEST( wall_flags_0 )
-
-      REAL(wp) ::  cellsum      !< Sum of child-grid node values over the anterpolation cell 
-      REAL(wP) ::  cellsumd     !< Sum of differences over the anterpolation cell 
-      REAL(wp) ::  fkj          !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkjp         !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkpj         !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkpjp        !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fk           !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkp          !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  rcorr        !< Average reversibility correction for the whole anterpolation cell
-      REAL(wp) ::  rcorr_ijk    !< Reversibility correction distributed to the individual child-grid nodes
-
-!      real(wp), parameter :: c1 =  2.0_wp / 6.0_wp
-!      real(wp), parameter :: c2 =  5.0_wp / 6.0_wp
-!      real(wp), parameter :: c3 = -1.0_wp / 6.0_wp
+      REAL(wp) ::  cb           !< Interpolation coefficient for the boundary ghost node  
+      REAL(wp) ::  cp           !< Interpolation coefficient for the first prognostic node
+      REAL(wp) ::  f_interp_1   !< Value interpolated in x direction from the parent-grid data
+      REAL(wp) ::  f_interp_2   !< Auxiliary value interpolated in x direction from the parent-grid data
 
 ! 
@@ -5874,69 +3434,41 @@
 !--      For u, nxl is a ghost node, but not for the other variables
          IF ( var == 'u' )  THEN
-            i     = nxl
-            iend  = nxl
             ibc   = nxl    
             ib    = ibc - 1
-            iawbc = 0
-            l     = icl + 2
             lw    = 2
+            lwp   = lw        ! This is redundant when var == 'u' 
             lbeg  = icl
-            loff  = 0            
          ELSE
-            i     = nxl - igsr
-            iend  = nxl - 1
             ibc   = nxl - 1
             ib    = ibc - 1
-            iawbc = igsr-1
-            l     = icl + 1
             lw    = 1
+            lwp   = 2
             lbeg  = icl
-            loff  = 0
          ENDIF        
       ELSEIF ( edge == 'r' )  THEN
          IF ( var == 'u' )  THEN
-            i     = nxr + 1            
-            iend  = nxr + 1
             ibc   = nxr + 1 
             ib    = ibc + 1
-            iawbc = 0
-            l     = icr - 1
             lw    = 1
+            lwp   = lw        ! This is redundant when var == 'u'            
             lbeg  = icr - 2
-            loff  = 0
          ELSE
-            i     = nxr + 1
-            iend  = nxr + igsr
             ibc   = nxr + 1
             ib    = ibc + 1
-            iawbc = 0
-            l     = icr - 1
             lw    = 1
+            lwp   = 0
             lbeg  = icr - 2
-            loff  = 1
          ENDIF         
       ENDIF
-
-      IF  ( var == 'w' )  THEN
-         ntopw = 1
+!
+!--   Interpolation coefficients
+      IF  ( interpolation_scheme_lrsn == 1 )  THEN
+         cb = 1.0_wp  ! 1st-order upwind 
+      ELSE IF  ( interpolation_scheme_lrsn == 2 )  THEN
+         cb = 0.5_wp  ! 2nd-order central
       ELSE
-         ntopw = 0
-      ENDIF
-
-      IF  ( var == 'v' )  THEN
-         mnorthv = 0
-      ELSE
-         mnorthv = 1
-      ENDIF
-
-      IF ( var == 'u' )  THEN 
-         var_flag = 1 
-      ELSEIF ( var == 'v' )  THEN
-         var_flag = 2 
-      ELSEIF ( var == 'w' )  THEN
-         var_flag = 3
-      ELSE
-         var_flag = 0
-      ENDIF
+         cb = 0.5_wp  ! 2nd-order central (default)
+      ENDIF         
+      cp    = 1.0_wp - cb
 !
 !--   Substitute the necessary parent-grid data to the work array workarrc_lr. 
@@ -5978,18 +3510,38 @@
       ENDIF
 
-      IF  ( var == 'v' )  THEN
+      IF  ( var == 'u' )  THEN
+
+         DO  m = jcsw, jcnw
+            DO n = 0, kct 
+               
+               DO  j = jfl(m), jfu(m)
+                  DO  k = kfl(n), kfu(n)
+                     f(k,j,ibc) = workarrc_lr(n,m,lw)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'v' )  THEN
          
          DO  m = jcsw, jcnw-1
             DO n = 0, kct 
 !
+!--            First interpolate to the flux point
+               f_interp_1 = cb * workarrc_lr(n,m,lw)   + cp * workarrc_lr(n,m,lwp)
+               f_interp_2 = cb * workarrc_lr(n,m+1,lw) + cp * workarrc_lr(n,m+1,lwp)
+!
 !--            Use averages of the neighbouring matching grid-line values
                DO  j = jfl(m), jfl(m+1)
-                  f(kfl(n):kfu(n),j,ibc) = 0.5_wp * ( workarrc_lr(n,m,lw)       &
-                       +  workarrc_lr(n,m+1,lw) )
+!                  f(kfl(n):kfu(n),j,ibc) = 0.5_wp * ( workarrc_lr(n,m,lw)       &
+!                       +  workarrc_lr(n,m+1,lw) )
+                  f(kfl(n):kfu(n),j,ibc) = 0.5_wp * ( f_interp_1 + f_interp_2 )
                ENDDO
 !
 !--            Then set the values along the matching grid-lines  
                IF  ( MOD( jfl(m), jgsr ) == 0 )  THEN
-                  f(kfl(n):kfu(n),jfl(m),ibc) = workarrc_lr(n,m,lw)
+!                  f(kfl(n):kfu(n),jfl(m),ibc) = workarrc_lr(n,m,lw)
+                  f(kfl(n):kfu(n),jfl(m),ibc) = f_interp_1
                ENDIF
             ENDDO
@@ -5998,6 +3550,8 @@
 !--      Finally, set the values along the last matching grid-line  
          IF  ( MOD( jfl(jcnw), jgsr ) == 0 )  THEN
+            f_interp_1 = cb * workarrc_lr(n,jcnw,lw) + cp * workarrc_lr(n,jcnw,lwp)
             DO  n = 0, kct
-               f(kfl(n):kfu(n),jfl(jcnw),ibc) = workarrc_lr(n,jcnw,lw)
+!               f(kfl(n):kfu(n),jfl(jcnw),ibc) = workarrc_lr(n,jcnw,lw)
+               f(kfl(n):kfu(n),jfl(jcnw),ibc) = f_interp_1
             ENDDO
          ENDIF
@@ -6020,6 +3574,10 @@
             DO n = 0, kct + 1   ! It is important to go up to kct+1  
 !
+!--            Interpolate to the flux point
+               f_interp_1 = cb * workarrc_lr(n,m,lw) + cp * workarrc_lr(n,m,lwp)
+!
 !--            First substitute only the matching-node values
-               f(kfu(n),jfl(m):jfu(m),ibc) = workarrc_lr(n,m,lw)
+!               f(kfu(n),jfl(m):jfu(m),ibc) = workarrc_lr(n,m,lw)
+               f(kfu(n),jfl(m):jfu(m),ibc) = f_interp_1
                   
             ENDDO
@@ -6038,12 +3596,15 @@
          ENDDO
 
-      ELSE   ! u or scalars
+      ELSE   ! any scalar
          
          DO  m = jcsw, jcnw
             DO n = 0, kct 
-               
+!
+!--            Interpolate to the flux point
+               f_interp_1 = cb * workarrc_lr(n,m,lw) + cp * workarrc_lr(n,m,lwp)
                DO  j = jfl(m), jfu(m)
                   DO  k = kfl(n), kfu(n)
-                     f(k,j,ibc) = workarrc_lr(n,m,lw)
+!                     f(k,j,ibc) = workarrc_lr(n,m,lw)
+                     f(k,j,ibc) = f_interp_1
                   ENDDO
                ENDDO
@@ -6069,10 +3630,5 @@
 
 
-   SUBROUTINE pmci_interp_1sto_sn( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
-                                   r2z, logc, logc_ratio, logc_kbounds,        &
-                                   nzt_topo_nestbc,                            &
-                                   kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc,   &
-                                   edge, var )
-
+   SUBROUTINE pmci_interp_1sto_sn( f, fc, kct, ifl, ifu, kfl, kfu, edge, var )
 !
 !--   Interpolation of ghost-node values used as the child-domain boundary
